
var designerContentUploadFileAry = [];

// CMS Content Import HTML5
function designerContentUploadSelectFileChange() {

    files = document.getElementById('designerContentUploadFileInput').files

    var html = '';

    $.each(files, function(key, fileObj) {
        // 取得副檔名
        var fileExtension = designerContentUploadGetFileExtension(fileObj.name);

        if ($.inArray('*.' + fileExtension, GlobalExtArray) < 0){
            // 檢查副檔名,不允許的檔案格式
            $().toastmessage('showWarningToast', fileObj.name + ' File Type Error');
        } else if (fileObj.size > (1024*1024*1024*1.99)) {
            // 檢查檔案大小,檔案太大
            $().toastmessage('showWarningToast', fileObj.name + ' ' + g_json.MSG_0101);
        } else if (fileObj.name.length > 50) {
            // 檢查檔名不能超過50個字
            $().toastmessage('showWarningToast', fileObj.name + ' ' + g_json.MSG_0114);
        } else {
            // 檢查是否有選擇重複的檔名
            designerContentUploadCheckDoubleFile(fileObj.name);
            // 將檔案寫入變數
            designerContentUploadFileAry.push(fileObj)
            // 取得檔案size
            var size = designerContentUploadGetFormatFileSize(fileObj);
            // UI
            html += '<div class="uploadifyQueueItem"><a href="javascript:void(0);" style="position: absolute;" onclick="designerContentUploadDelete(this)"><img src="images/cancel.png"></a><span class="up_filename" file_name="'+fileObj.name+'" style="padding-left: 16px;">'+fileObj.name+'</span> <span>('+size+')</span> <span class="uploadStatus"></span></div>';
        }
    });

    $('#custom-queue').append(html);

    SubBottomMenuSwitch("ContentSubMenuUpload");

    subDesignerSwitch("subContentUpload");
}

// 取得副檔名
function designerContentUploadGetFileExtension(filename) {

  result = (/[.]/.exec(filename)) ? /[^.]+$/.exec(filename)[0] : undefined;

  result = result.toLowerCase();

  return result;
}

// 檢查是否有選擇重複的檔名
function designerContentUploadCheckDoubleFile(fileName) {

    $.each(designerContentUploadFileAry, function(key, fileObj) {

        if (fileName == fileObj.name) {
            // 刪除資料
            designerContentUploadFileAry.splice(key, 1);
            // 刪除UI
            $('.up_filename[file_name="'+fileName+'"]').parents('.uploadifyQueueItem').remove();

            return false;
        }
    });
}

// 刪除單個檔案
function designerContentUploadDelete(e) {
    // 取得檔名
    var fileName = $(e).parents('.uploadifyQueueItem').find('.up_filename').html();
    // 刪除UI
    $(e).parents('.uploadifyQueueItem').remove();
    // 迴圈刪除相同檔名的資料
    $.each(designerContentUploadFileAry, function(key, fileObj) {

        if (fileObj.name == fileName) {

            designerContentUploadFileAry.splice(key, 1);

            return false;
        }
    });
}

// 上傳
function designerContentUploadStartAction() {
    // 檢查有沒有檔案
    if (designerContentUploadFileAry.length == 0) {
        return false;
    }

    $( "#desImg" ).html("").children().remove();

    $("#blockUI").show();

    var doneTotal = 0;

    $.each(designerContentUploadFileAry, function(key, fileObj) {

        var newform = new FormData();

        newform.append("Filedata", fileObj, fileObj.name);

        newform.append("Filename", fileObj.name);

        newform.append("fileext", GlobalExtArray.join(";"));

        newform.append("folder", '/opt/PowerDigiS/content');

        newform.append("Upload", 'Submit Query');

        $.ajax({
            async: true,
            type: "POST",
            dataType: "html",
            url:"/Designer/Designer_uploadify.php",
            data: newform,
            enctype: 'multipart/form-data',
            processData: false,
            contentType: false,
            success: function(data){
                // onOpen
                $.post("Designer_uploadify.php", { "opt":"onOpen",  "OriFileName": fileObj.name ,"FileType":'.'+designerContentUploadGetFileExtension(fileObj.name) ,"FileSize":fileObj.size});
                // 單個上傳完成
                designerContentUploadOnComplete(fileObj);
                // 增加上傳完成數量
                doneTotal += 1;
                // 檢查是否全部都上傳完成了
                if (doneTotal >= designerContentUploadFileAry.length) {
                    // 全部上傳完成
                    designerContentUploadOnQueueComplete();
                }

            },
            error: function() {
                console.log('Ajax Error');
            },
            xhr: function () {
                var myXhr = $.ajaxSettings.xhr(); //取得XMLHttpRequest加入progress事件
                if (myXhr.upload) {

                    myXhr.upload.addEventListener('progress', function () {
                        // 計算進度
                        var progressRate = parseInt((event.loaded/event.total)*100);

                        if (progressRate == 100) {
                            // 顯示完成
                            $($('.uploadifyQueueItem')[key]).find('.uploadStatus').html(' - complete');

                            setTimeout("$($('.uploadifyQueueItem')["+key+"]).hide();", 1000)
                        } else {
                            // 顯示百分比
                            $($('.uploadifyQueueItem')[key]).find('.uploadStatus').html(': '+progressRate+'%');
                        }

                    }, false);
                }

                return myXhr;
            }
        });
    });

    return true;
}

// 單個完成時執行
function designerContentUploadOnComplete(fileObj) {

    $.post("Designer_uploadify.php", { "opt":"onComplete",  "OriFileName": fileObj.name  }, function(data) {

        data = $.trim(data);

        if ( data.length > 0 ) {

            $().toastmessage('showWarningToast',fileObj.name +" "+ g_json[data]);
        } else {

            $.post("Designer_Content.php", { "opt":"ConvertFile","type":fileObj.type,"name":fileObj.name,"convert":g_designer.Content.FileConvert });
        }

        Content_Table();
    });
}

// 全部上傳完成時
function designerContentUploadOnQueueComplete() {

    designerContentUploadFileAry = [];

    $('#custom-queue').html('');

    $("#blockUI").hide();

    CheckContentExist();

    SubBottomMenuSwitch("ContentSubMenu");

    subDesignerSwitch("subContentProp");
}

// 取得檔案size
function designerContentUploadGetFormatFileSize (fileObj){

    size = fileObj.size;

    if (size > 1024 * 1024) {

        size = (Math.round(size * 100 / (1024 * 1024)) / 100).toString() + 'MB';
    } else {

        size = (Math.round(size * 100 / 1024) / 100).toString() + 'KB';
    }

    return size;
}

$(document).ready(function() {
    // 點擊Start Upload
    $("#StartUpload").click(function(){

        // 檢查不能超過100個
        if ($("#custom-queue").children('div .uploadifyQueueItem').length > 100) {

            $().toastmessage('showWarningToast',g_json.Designer_content_UploadMaxSize);

            return false
        }

        // 檢查重複
        var postData = new Object();

        postData['folder'] = '/opt/PowerDigiS/content';

        $.each($('.up_filename'), function(key,va) {

            postData[key] = $(va).html();
        });

        // check file name
        $.post('/Designer/Designer_uploadifyCheck.php', postData, function(data) {

            for(var key in data) {
                // UI上加上- already exists
                $('.up_filename[file_name="'+data[key]+'"]').parents('.uploadifyQueueItem').find('.uploadStatus').html(' - already exists');
            }

            for(var key in data) {

                var replaceFile = confirm(g_json.Designer_content_ReplaceTheFile+" " + data[key] + "?");

                if ( ! replaceFile) {

                    return false;
                }
            }

            // 開始上傳
            return designerContentUploadStartAction();

        }, "json");
    });

    // 點擊 All Cancel
    $("#AllCancelUpload").click(function(){

        if (confirm(g_json.Designer_content_CancelAlluploading)) {

            designerContentUploadFileAry = [];

            $('#custom-queue').html('');

            CheckContentExist();

            $("#StartUpload").show();
        }
        return false;
    });
});